

#if !defined __VPIXCON_H
#define __VPIXCON_H


#include "anineutr.h"
#include "gamequrk.h"

#include "vissim.h"
#include "camera_ai.h"


/* **************************************************************
************************************************************** */
class pcam_ai : public camera_ai {

   protected: 
      int nix_tunneling(double *x, double *y, double *z);
      int clamp_tunneling(double *x, double *y, double *z);

   public:
      virtual ~pcam_ai() {}
};


/* ****************************************************************
**************************************************************** */
class pixtron : public antineutron {

   public:
      void preprocess(void *data);
};


/* ****************************************************************
**************************************************************** */
class pixtron_loader : public quark_loader {

   public:
      superclass *make_object() { return new pixtron; }
      pixtron_loader() {
         object_name = TOKEN_ANTINEUTRON_STR;
         alias_name  = TOKEN_NEUTRON_STR;
      }

};


/* **************************************************************
************************************************************** */
class pix_data : public platform_data {

   protected:
      gameatom *player;

   public:
      void label(dbl_llist_manager *label_manager);
      void update(double *machine_time);
      int  perform(iface *isim, int task, void *data);
      void render(iface *isim);
      int init(iface *isim, correlate *basis, symbol_correlation_type *str);

      pix_data(basic_platform *x);
      virtual ~pix_data();
};


gameatom *load_atom(char *filename);
int point_terrain_collision(quark *obstacle, quark *parent, double *start, double *end, double *midpt, double *radius, double *down, double *pos, double *normal);

void vfx_init();
void vfx_dest();

void vfx_dazzle_the_crowd(void *buffer);

extern camera   *current_camera;

extern gameatom *pixcon_object_list;               // atom list
extern gameatom *camera_tree;
extern gameatom *enviro_tree;
extern gameatom *terrain_tree;

#endif

